// Verilog HDL for "UofU_Digital_v1_2", "DCBX1" "behavioral"

module DCBX1 (CLR, D, CLK, Q, QB);
    input CLR;
    input D;
    input CLK;
    output Q;
    output QB;

reg Q_i, QB_i;

always @(posedge CLK or negedge CLR)
	if (CLR == 0) 
	    begin
		Q_i = 1'b0;
		QB_i = 1'b1;
	    end
	else
	    begin 
		Q_i = D;
		QB_i = ~D;
	    end

buf _i0 (Q, Q_i);
buf _i1 (QB, QB_i);

	specify
	(CLK *> Q) = (1.0, 1.0);
	(CLK *> QB) = (1.0, 1.0);
	(CLR *> Q) = (1.0, 1.0);
	(CLR *> QB) = (1.0, 1.0);
	$setuphold(posedge CLK, D, 0.1, 0.0);
//	$setup(D, posedge CLK, 0.1);
//	$hold(posedge CLK, D, 0.0);
	$recovery(negedge CLR, posedge CLK, 0.0);
	endspecify

endmodule
