// Verilog HDL for "UofU_Example", "DFFX1" "behavioral"

module DFFX1 (CLR, D, CLK, Q, QB);
    input CLR;
    input D;
    input CLK;
    output Q;
    output QB;

reg Q_i, QB_i;

always @(posedge CLK or negedge CLR)
	if (CLR == 0) 
	    begin
		Q_i = 1'b0;
		QB_i = 1'b1;
	    end
	else
	    begin 
		Q_i = D;
		QB_i = ~D;
	    end

buf _i0 (Q, Q_i);
buf _i1 (QB, QB_i);

	specify
	(CLK *> Q) = (1.0, 1.0);
	(CLK *> QB) = (1.0, 1.0);
	(CLR *> Q) = (1.0, 1.0);
	(CLR *> QB) = (1.0, 1.0);
	$setuphold(posedge CLK, D, 0.1, 0.0);
//	$setup(D, posedge CLK, 0.1);
//	$hold(posedge CLK, D, 0.0);
	$recovery(negedge CLR, posedge CLK, 0.0);
	endspecify

endmodule

// Verilog HDL for "UofU_Example", "INVX1" "behavioral"

module INVX1 (Y, A);
    output Y;
    input A;

   not _i0 (Y, A);

   specify
      (A => Y) = (1.0, 1.0);
   endspecify

endmodule

// Verilog HDL for "UofU_Example", "NAND2X1" "behavioral"

module NAND2X1 (Y, A, B);
    output Y;
    input A;
    input B;

   nand _i0(Y, A, B);

   specify
      (A => Y) = (1.0, 1.0);
      (B => Y) = (1.0, 1.0);
   endspecify

endmodule

// Verilog HDL for "UofU_Example", "NOR2X1" "behavioral"

module NOR2X1 (Y, A, B);
    output Y;
    input A;
    input B;

   nor _i0(Y, A, B);

   specify
      (A => Y) = (1.0, 1.0);
      (B => Y) = (1.0, 1.0);
   endspecify

endmodule

// Verilog HDL for "UofU_Example", "TIEHI" "behavioral"

module TIEHI (Y);
    output Y;

   assign  Y = 1'b1;
   
endmodule

// Verilog HDL for "UofU_Example", "TIELO" "behavioral"

module TIELO (Y);
    output Y;

   assign  Y = 1'b0;
   
endmodule

